import java.io.UncheckedIOException;
import java.util.*;

public class Arraz {


    public static int sumIntArray(int[] arr) {
        int result = 0;
        for (int number: arr) {
            result += number;
        }
        return result;
    }

    public static double sumDoubleArray(double[] arr) {
        double result = 0;
        for (double number: arr) {
            result += number;
        }
        return result;
    }


    public static int sumValuesOf2Array(int[] arr1, int[] arr2) {

        int firstAmount = sumIntArray(arr1);

        int secondAmount = sumIntArray(arr2);

        int amount = firstAmount + secondAmount;

        return amount;
    }

    public static double sumDoublesOf2Array(double[] arr1, double[] arr2) {

        double firstAmount = sumDoubleArray(arr1);

        double secondAmount = sumDoubleArray(arr2);

        double amount = firstAmount + secondAmount;

        return amount;

    }


    public static int averageOfArrays(int[] arr) {

       return sumIntArray(arr)/arr.length;
    }

    public static double doubleAverageOfArrays(double[] arr) {
        return sumDoubleArray(arr)/arr.length;
    }


    public static boolean containsValue(int[] arr, int number) {
        for (int n : arr) {
            if(number == n){
                return true;
            }
        }
                return false;
    }

    public static int[] reverseArray(int[] arr) {

        for(int i = 0; i < arr.length/2; i++){
            int temp = arr[i];

            arr[i] = arr[arr.length-i-1];
            arr[arr.length-i-1] = temp;
        }

        return arr;

    }

    public static OddEven getOddEvensOfArray(int[] arr){
        int odd = 0;
        int even = 0;

        for(int i = 0; i < arr.length; i++){
            if(arr[i] % 2 == 0){
                even++;
            }else {
                odd++;
            }
        }

        return new OddEven(even,odd);
    }

    public static int findIndexOf(int[] arr, int n) {

        for(int i = 0; i <arr.length; i++){
            if(arr[i] == n){
                return i;
            }
        }return -1;


    }

    public static Integer[] copyArrayByIterator(Integer[] arr) {

        Iterator<Integer> iterator = Arrays.asList(arr).iterator();
        Integer[] newArr = new Integer[arr.length];
        int i = 0;

        while(iterator.hasNext()){
            newArr[i] = iterator.next();
            i++;
        }
        return newArr;
    }

    public static int[] copyArrayByLoop(int[] arr) {
        int[] newArr = new int[arr.length];

        for(int i = 0; i < arr.length; i++){
            newArr[i] = arr[i];
        }
        return newArr;
    }


    public static int[] toIntArray(Integer[] array){
        int[] ret = new int[array.length];
        for(int i = 0; i < array.length;i++){
            ret[i] = array[i];
        }
        return ret;
    }


    public static int[] removeElementFromArray(int[] arr, Integer number) {


        ArrayList<Integer> list = new ArrayList<Integer>();

        for(int n : arr){
            list.add(n);
        }

        for(int m : arr) {
            list.remove(new Integer(number));
        }

        Integer[] elementRemovedArray = list.toArray(new Integer[list.size()]);



        return  toIntArray(elementRemovedArray );
    }

    public static int[] insertIntoArrayAt(int[] arr, int index, int number) {

        int[] newArr = new int[arr.length+1];

        for(int i = 0; i < arr.length; i++){

            if(i == index){
                arr[index] = number;
            }
            newArr[i] = arr[i];
        }
        return newArr;
    }

    public static MaxMin findMaxMinOfArray(int[] arr) {

        Arrays.sort(arr);

        int max = arr[arr.length-1];
        int min = arr[0];

        return new MaxMin(max,min);
    }

    public static Integer[] removeDupesFromArray(Integer[] arr) {


        ArrayList<Integer> list = new ArrayList<Integer>();

        HashSet<Integer> set = new HashSet<Integer>();

        for(Integer n : arr){
            list.add(n);
        }

        set.addAll(list);
        list.clear();
        list.addAll(set);


        Integer[] array = list.toArray(new Integer[0]);

        Arrays.sort(array);
        return array;
    }


    public static double find2ndLargestValueFromArray(double[] arr) {

        ArrayList<Double> list = new ArrayList<Double>();

        HashSet<Double> set = new HashSet<Double>();

        for(Double n : arr){
            list.add(n);
        }

        set.addAll(list);
        list.clear();
        list.addAll(set);

        Double[] array = list.toArray(new Double[0]);

        Arrays.sort(array);


        for (int i = 0 ; i < array.length; i++){
            if(array[i] != array[i + i]){
                return array[array.length-2];
            }
        }
            return -1;
    }


    public static ArrayList makeMeAnArrayListFromArray(Object[] array) {

        ArrayList arrayList = new ArrayList(Arrays.asList(array));

        return arrayList;
    }

    public static Object[] makeMeAnArrayFromArrayList(ArrayList arrayList) {

        Object[] arr = arrayList.toArray();

        return arr;
    }

    public static boolean check2ArraysForEqual(Object[] arr1, Object[] arr2) {


        int counter = 0;
        for(int i = 0; i < arr1.length; i++){
            for(int j = 0; j < arr2.length; j++){
                if(arr1[i] == arr2[j]){
                    counter++;
                }
            }
        }
        if(counter == arr1.length && counter == arr2.length){
            return true;
        }
        return false;
    }

    public static int averageArrayWithoutMaxMin(int[] array) {

        MaxMin maxMin = findMaxMinOfArray(array);

        int max = maxMin.getMax();
        int min = maxMin.getMin();



        int[] arrayWithoutMax = removeElementFromArray(array,max);

        int[] arrayWithoutBoth = removeElementFromArray(arrayWithoutMax,min);



        return averageOfArrays(arrayWithoutBoth);
    }

    public static boolean arrayHas65and77(int[] array){
        int counter = 0;

        if(containsValue(array,65) && containsValue(array, 77)){
            return true;
        }

//        if(containsValue(array,77)){
//            counter++;
//        }
//        for (int i = 0 ; i < array.length; i++){
//            if(array[i] == 65){
//                counter++;
//            }
//            else if(array[i] == 77){
//                counter++;
//            }
//        }

//        if(counter >= 2){
//            return true;
//        }
        return false;
    }


}
